//  adjspr.c - Alter a sprite setting

#include <mtxscrn.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
    Adjusts a value asigned to a sprite.

    p = Parameter to assign (see table below).
    n = Sprite number.
    v = Value to assign.

    +-+----------+-----------------------------------------------------+
    |p|Meaning   |Range for v                                          |
    +-+----------+-----------------------------------------------------+
    |0|Pattern   |0 - 127 for size 0 sprites. 0 - 31 for size 1 sprites|
    |1|Colour    |0 - 15                                               |
    |2|X position|0 - 255                                              |
    |3|Y position|0 - 255                                              |
    |4|X speed   |0 - 255 (128 - 255 treated as negative)              |
    |5|Y speed   |0 - 255 (128 - 255 treated as negative)              |
    +-+----------+-----------------------------------------------------+
*/

void adjspr (unsigned char p, unsigned char n, unsigned char v) __naked
    {
    p; n; v;
    __asm
        getstr = 0x00BC
#if __SDCCCALL == 1
        push    af              ; Save first parameter (in A)
#endif
        ld      a, #0x11        ; <Ctrl+Q>
        call    getstr
        ld      b, #3           ; Three parameters
        jp      _mxl_putparam
    __endasm;
    }
