//  close.c - Close a file after writing

#include <diskio.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
   Close a file after writing.

   fcb =    Pointer to file control block.
   return: 0 - OK. 1 - Close failed.
*/

unsigned char close (FCB *fcb) __naked
    {
    fcb;
    __asm
        bdos = 0xD706
#if __SDCCCALL != 1
        ld      hl, #2      // Pointer to parameters
        add     hl, sp
        ld      e, (hl)     // FCB pointer
        inc     hl
        ld      d, (hl)
        inc     hl
#endif
        ld      c, #0x10    // Close file
        call    bdos        // Perform the action
        inc     a           // Test for action failed
        jr      z, 00002$   // Jump if so
        xor     a
#if __SDCCCALL != 1
        ld      l, a
#endif
        ret
00002$:
#if __SDCCCALL == 1
        ld      a, #1
#else
        ld      l, #1
#endif
        ret
    __endasm;
    }
