//  crvs.c - Create virtual screen

#include <mtxscrn.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
    Create and select a virtual screen.

    n = Virtual screen number (0 - 7).
    t = Type of screen (0 = text, 1 = graphics).
    x = Horizontal position of left corner (0 - 39 or 31).
    y = Vertical position of top corner (0 - 23).
    w = Width of virtual screen (x + w &lt;= 40 or 32).
    h = Height of virtual screen (y + h &lt;= 24).
    s = Physical screen width (40 or 32).

*/

void crvs (unsigned char n, unsigned char t, unsigned char x, unsigned char y,
		   unsigned char w, unsigned char h, unsigned char s) __naked
    {
    n; t; x; y; w; h; s;
    __asm
        getstr = 0x00BC
#if __SDCCCALL == 1
        push    af              ; Save first parameter (in A)
#endif
        ld      a, #0x1B        ; <Esc>
        call    getstr
        ld      a, #'Y'
        call    getstr
        ld      b, #7           ; Seven parameters
        jp      _mxl_putparam
    __endasm;
    }
