//  ctlspr.c - Control sprite parameters

#include <mtxscrn.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
    Set parameters to control sprites:

    +-+--------------------------+--------------------------------------------------------------+
    |p|Meaning                   |Range for v                                                   |
    +-+--------------------------+--------------------------------------------------------------+
    |0|Speed (1 is fastest)      |1 - 255, 0 = 256                                              |
    |1|Distance to move          |1 - 255                                                       |
    |2|Number of sprites         |0 - 32                                                        |
    |3|Number of circling sprites|0 - 32                                                        |
    |4|Plot sprite number        |0 - 32                                                        |
    |5|Number of moving sprites  |0 - 32                                                        |
    |6|Magnitude and size        |0 = 8x8 mag 1. 1 = 8x8 mag 2. 2 = 16x16 mag 1. 3 = 16x16 mag 2|
    +-+--------------------------+--------------------------------------------------------------+
*/

void ctlspr (unsigned char p, unsigned char x) __naked
    {
    p; x;
    __asm
        getstr = 0x00BC
#if __SDCCCALL == 1
        push    af              ; Save first parameter (in A)
#endif
        ld      a, #0x0E        ; <Ctrl+N>
        call    getstr
        ld      b, #2           ; Two parameters
        jp      _mxl_putparam
    __endasm;
    }
