//  currec.c - Get the current record number in a file.

#include <diskio.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
   Get the current record number in a file.

   fcb =    Pointer to file control block.
   return:  Current record number.
*/

unsigned int currec (FCB *fcb) __naked
    {
    fcb;
    __asm
        bdos = 0xD706
#if __SDCCCALL == 1
        ex      de, hl      // DE = FCB pointer
#else
        ld      hl, #2      // Pointer to parameters
        add     hl, sp
        ld      e, (hl)     // FCB pointer
        inc     hl
        ld      d, (hl)
#endif
        push    de          // Save the FCB pointer
        ld      c, #0x24    // Get current record
        call    bdos        // Perform the action
        pop     hl          // Restore the FCB pointer
        and     a           // Test for error
        jr      nz, 00001$
        ld      bc, #32     // Offset to record number
        add     hl, bc
        ld      e, (hl)     // Get record number
        inc     hl
        ld      d, (hl)
#if __SDCCCALL != 1
        ex      de, hl      // Result in HL
#endif
        ret
00001$:
#if __SDCCCALL == 1
        ld      de, #0      // Error, return zero
#else
        ld      hl, #0      // Error, return zero
#endif
        ret
    __endasm;
    }
