//  genpat.c - Define a character or sprite pattern

#include <mtxscrn.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
    Define a pattern for a character or sprite.

    +-+-----------------------------------+---------+-------------------+
    |p|Meaning                            |n        |d1 ... d8          |
    +-+-----------------------------------+---------+-------------------+
    |0|Redefine an ASCII character        |32 - 127 |Pixels for each row|
    |1|Redefine a non-ASCII character     |129 - 154|Pixels for each row|
    |2|Colours for each row of a character|147 - 154|16 * paper + ink   |
    |3|Pattern for 8x8 sprite             |0 - 127  |Pixels for each row|
    |4|NW quarter of a 16x16 sprite       |0 - 31   |Pixels for each row|
    |5|SW quarter of a 16x16 sprite       |0 - 31   |Pixels for each row|
    |6|NE quarter of a 16x16 sprite       |0 - 31   |Pixels for each row|
    |7|SE quarter of a 16x16 sprite       |0 - 31   |Pixels for each row|
    +-+-----------------------------------+---------+-------------------+
*/

void genpat (unsigned char p, unsigned char n,
			 unsigned char d1, unsigned char d2, unsigned char d3, unsigned char d4,
			 unsigned char d5, unsigned char d6, unsigned char d7, unsigned char d8) __naked
    {
    p; n; d1; d2; d3; d4; d5; d6; d7; d8;
    __asm
        getstr = 0x00BC
#if __SDCCCALL == 1
        push    af              ; Save first parameter (in A)
#endif
        ld      a, #0x0F        ; <Ctrl+O>
        call    getstr
        ld      b, #10          ; Ten parameters
        jp      _mxl_putparam
    __endasm;
    }
