//  getchar.c - Read a character from the keyboard

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
    Reads a character from the keyboard. Waits until the key has been released.

*/

int getchar (void) __naked
    {
    __asm
        kbd = 0x0079
00001$:
        call    kbd         ; Read keyboard
        and     a           ; Test for no key
        jr      z, 0001$    ; Repeat if no key pressed
        push    af          ; Save character code
00002$:
        call    kbd         ; Wait for key release
        and     a
        jr      nz, 00002$
#if __SDCCCALL == 1
        ld      d, a        ; Zero D
        pop     af          ; Restore character
        ld      e, a        ; Return character in E
#else
        ld      h, a        ; Zero H
        pop     af          ; Restore character
        ld      l, a        ; Return character in L
#endif
        ret
    __endasm;
    }
