// getiff.c - Test for interrupts enabled


#include <mtxint.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
   Test for interrupts enabled.

   Return:  0 - Interrupts disabled
   Return:  0xFF - Interrupts enabled

*/

unsigned char getiff (void) __naked
    {
    __asm
        call    getiff      ; Return carry flag clear if interrupts enabled
        ccf                 ; Convert to true / false value
        sbc     a, a
#if __SDCCCALL != 1
        ld      l, a
#endif
        ret
getiff::                    ; Test IFF2 working around ld a,i issue
        xor     a           ; Clear A and CF
        push    af          ; Zero on stack
        pop     af          ; Restore stack
        ld      a, i        ; PF = IFF2
        ret     pe          ; Exit (CF clear) if interrupts enabled
        dec     sp          ; Take a look at bottom of stack
        dec     sp
        pop     af
        and     a           ; Test for non-zero, an interrupt occurred
        ret     nz
        scf                 ; Interrupts really disabled
        ret
    __endasm;
    }
