// mtxscrn.s - Routines to send control or escape sequences

#ifndef H_MTXSCRN
#define H_MTXSCRN

/**
   Routines for controlling the MTX screen. They are entries to the corresponding
   MTX ROM routines. Parameter errors are likely to result in the program being
   terminated with the corresponding MTX BASIC error message. In some cases a
   crash requiring a reboot may result.
*/

void adjspr (unsigned char p, unsigned char n, unsigned char v);
void attr (unsigned char p, unsigned char state);
void cls (void);
void colour (unsigned char p, unsigned char n);
void crvs (unsigned char n, unsigned char t, unsigned char x, unsigned char y,
           unsigned char w, unsigned char h, unsigned char s);
void csrdown (void);
void csrhome (void);
void csrleft (void);
void csroff (void);
void csron (void);
void csrright (void);
void csrup (void);
void ctlspr (unsigned char p, unsigned char v);
void cursor (unsigned char x, unsigned char y);
void eol (void);
void genpat (unsigned char p, unsigned char n,
             unsigned char d1, unsigned char d2, unsigned char d3, unsigned char d4,
             unsigned char d5, unsigned char d6, unsigned char d7, unsigned char d8);
void ink (unsigned char clr);
char inkey (void);
void line (unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2);
void movspr (unsigned char p, unsigned char n, unsigned char d);
void pagemode (void);
void paper (unsigned char clr);
void plot (unsigned char x, unsigned char y);
void scrlmode (void);
void sprite (unsigned char n, unsigned char p, unsigned int xp, unsigned int yp,
    signed char xs, signed char ys, unsigned char c);
void view (unsigned char dir, unsigned char dis);
void vs (unsigned char n);

#endif
