// mtxsnd.h - SDCC callable routines providing sound on an MTX

#ifndef H_MTXSND
#define H_MTXSND

/**
   Routines for controlling the MTX sound generator. They are entries to the
   corresponding MTX ROM routines. Parameter errors are likely to result in
   the program being terminated with the corresponding MTX BASIC error message.
   In some cases a crash requiring a reboot may result.
*/

void killsnd (void);
void sbuf (unsigned int nbuf);
void sound3 (unsigned int chan, unsigned int freq, unsigned int vol);
void sound7 (unsigned int chan, unsigned int freq, unsigned int vol,
	     unsigned int finc, unsigned int vinc, unsigned int durn,
	     unsigned int mode);

#endif
