//  inport.c - Read data from a Z80 I/O port

#include <ioport.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
    Read a value from a Z80 I/O port. The full 16 bit address is used. The only known
    MTX add-on which makes use of the high byte of the address is Speculator.

*/

unsigned char inport (unsigned int addr) __naked
    {
    addr;
    __asm
#if __SDCCCALL == 1
        ld      c, l        ; Copy address
        ld      b, h
        in      a, (c)      ; Get the port contents
#else
        ld      hl, #2      ; Start of parameters
        add     hl, sp
        ld      c, (hl)     ; Low byte of address
        inc     hl          ; High byte of address
        ld      b, (hl)
        in      l, (c)      ; Get the port contents
#endif
        ret
    __endasm;
    }
