//  movspr.c - Move a sprite

#include <mtxscrn.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
    Controls a sprite in a number of ways. The value of p can be summed to perform multiple actions.
    The value of d must be consistent with all the selected actions.

    n = Sprite number (1 - 32).

    +-+---------------------------------------+------------------------------+
    |p|Meaning                                |d                             |
    +-+---------------------------------------+------------------------------+
    |1|Move sprite 1 step                     |Direction of movement (0 - 8) |
    |2|Change the sprites pattern             |Pattern number (0 - 31 or 127)|
    |4|Change the direction of sprite movement|Direction of movement (0 - 8) |
    |8|Plot at centre of sprite               |Ignored                       |
    +-+---------------------------------------+------------------------------+
*/

void movspr (unsigned char p, unsigned char n, unsigned char d) __naked
    {
    p; n; d;
    __asm
        getstr = 0x00BC
#if __SDCCCALL == 1
        push    af              ; Save first parameter (in A)
#endif
        ld      a, #0x13        ; <Ctrl+S>
        call    getstr
        ld      b, #3           ; Three parameters
        jp      _mxl_putparam
    __endasm;
    }
