//  mxl_fileini.c - Perform a number of file actions

#include <diskio.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/*
   Perform a number of BDOS file actions. This routine is entered by a jump not a call.

   c =      BDOS action to perform.
   fcb =    Pointer to file control block.
   fn =     Pointer to file name. If NULL the FCB is assumed to contain a file name.
   return:  0 - OK. 1 - Invalid drive. 2 - Name too long. 3 - Extension too long. 4 - Open failed.
*/

unsigned char mxl_fileini (FCB *fcb, const char *fn) __naked
    {
    fcb; fn;
    __asm
        bdos = 0xD706
#if __SDCCCALL != 1
        ld      hl, #2      // Pointer to parameters
        add     hl, sp
        ld      e, (hl)     // FCB pointer
        inc     hl
        ld      d, (hl)
        inc     hl
        push    de
        ld      e, (hl)     // File name pointer
        inc     hl
        ld      d, (hl)
        pop     hl
#endif
        push    bc          // Save the action to perform
        push    hl          // Save the FCB pointer
        ld      a, d        // Test for file name
        or      e
        call    nz, mxl_fname   // Set file name
        pop     hl
        push    hl          // Zero ex, s1, s2 and rc
        ld      bc, #12
        add     hl, bc
        xor     a
        ld      b, #4
00001$:
        ld      (hl), a
        inc     hl
        djnz    00001$
        ld      bc, #16     // Zero cr
        add     hl, bc
        ld      (hl), a
        pop     de          // Restore the FCB pointer
        pop     bc          // Restore the required action
        call    bdos        // Perform the action
        inc     a           // Test for action failed
        jr      z, 00002$   // Jump if so
        xor     a
#if __SDCCCALL != 1
        ld      l, a
#endif
        ret
00002$:
#if __SDCCCALL == 1
        ld      a, #4
#else
        ld      l, #4
#endif
        ret
    __endasm;
    }
