//  mxl_fileio - Perform sequential file I/O

#include <diskio.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/*
   Perform sequential file I/O. This routine is entered by a jump not a call.

   c =      Read or write operation
   fcb =    File Control Block to use for the search.
   data =   Pointer to buffer to receive directory entry (NULL = Use last).
   Return:  Zero for success, non-zero on error.
*/

unsigned char mxl_fileio (FCB *fcb, void *data) __naked
    {
    fcb; data;
    __asm
        bdos = 0xD706
#if __SDCCCALL == 1
        push    hl          // Save FCB pointer
#else
        ld      hl, #2      // Pointer to parameters
        add     hl, sp
        ld      e, (hl)     // FCB pointer
        inc     hl
        ld      d, (hl)
        inc     hl
        push    de
        ld      e, (hl)     // DMA address
        inc     hl
        ld      d, (hl)
#endif
        push    bc          // Save action number
        call    mxl_setdma  // Set DMA address (if not NULL)
        pop     bc
        pop     de          // Restore FCB pointer
        call    bdos        // Perform action
#if __SDCCCALL != 1
        ld      l, a
#endif
        ret

    __endasm;
    }
