//  mxl_randio.c - Perform random file I/O operations.

#include <diskio.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/*
   Perform random file I/O. This routine is entered by a jump not a call.

   c =      Read or write operation
   fcb =    File Control Block.
   data =   Pointer to buffer for data.
   recno =  Record number to process.
   Return:  Zero for success, non-zero on error.
*/

unsigned char mxl_randio (FCB *fcb, void *data, unsigned int recno) __naked
    {
    fcb; data; recno;
    __asm
        bdos = 0xD706
#if __SDCCCALL != 1
        ld      hl, #2      // Pointer to parameters
        add     hl, sp
        ld      e, (hl)     // FCB pointer
        inc     hl
        ld      d, (hl)
        inc     hl
        push    de
        ld      e, (hl)     // DMA Address
        inc     hl
        ld      d, (hl)
        inc     hl
        ex      (sp), hl    // Restore FCB pointer and save parameter pointer
#endif
        push    hl          // Save FCB pointer
        push    bc          // Save action number
        call    mxl_setdma  // Set DMA address (if not NULL)
        pop     bc
#if __SDCCCALL == 1
        pop     de          // Save FCB pointer in DE
        pop     hl          // Return address
        ex      (sp), hl    // HL = Record number. Return address back on stack.
        ex      de, hl      // Registers back in correct order
#else
        pop     hl
        ex      (sp), hl    // Save FCB pointer. HL = Parameter pointer
        ld      e, (hl)     // Record number
        inc     hl
        ld      d, (hl)
        pop     hl          // Restore FCB pointer.
#endif
        push    bc          // Save action number
        push    hl          // Save FCB pointer
        ld      bc, #33     // Offset to register number
        add     hl, bc
        ld      (hl), e
        inc     hl
        ld      (hl), d
        inc     hl
        ld      (hl), #0
        pop     de          // Restore FCB pointer
        pop     bc          // Restore action number
        call    bdos        // Perform action
#if __SDCCCALL != 1
        ld      l, a
#endif
        ret
    __endasm;
    }
