//  outport.c - Write data to a Z80 I/O port

#include <ioport.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
    Write a to from a Z80 I/O port. The full 16 bit address is used. The only known
    MTX add-on which makes use of the high byte of the address is Speculator. The data
    is specified as 16-bit as this results in a more efficient subroutine call. Only the
    lower byte of the data variable is actually used.

*/

void outport (unsigned int addr, unsigned int data) __naked
    {
    addr; data;
    __asm
#if __SDCCCALL == 1
        ld      c, l        ; Copy address
        ld      b, h
#else
        ld      hl, #2      ; Start of parameters
        add     hl, sp
        ld      c, (hl)     ; Low byte of address
        inc     hl          ; High byte of address
        ld      b, (hl)
        inc     hl          ; Low byte of the data
        ld      e, (hl)
#endif
        out     (c), e      ; Write data to the port
        ret
    __endasm;
    }
