//  pause.c - Pause for an interval

#include <mtxsnd.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
    Pause for a period. The duration of the pause is determined by the number
    of interrupts occurring. By default, in BASIC, that is one every 8ms.

    wait = Number of interrupt periods to wait for.

*/

void pause (unsigned int wait) __naked
    {
    wait;
    __asm
#if __SDCCCALL != 1
        ld      hl, #2          ; Pointer to parameter
        add     hl, sp
        ld      a, (hl)         ; Load the parameter
        inc     hl
        ld      h, (hl)
        ld      l, a
#endif
000001$:
        ld      a, h            ; Test for zero
        or      l
        ret     z
        halt                    ; Wait for interrupt (1/125 sec)
        dec     hl              ; Count delay
        jr      000001$
    __endasm;
    }
