//  sbuf.c - Allocate a number of sound buffers

#include <mtxsnd.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
    Define the number of sound buffers to use for each channel.

*/

void sbuf (unsigned int nbuf) __naked
    {
    nbuf;
    __asm
        conok = 0x27C0
        page = 0xFAD2
#if __SDCCCALL == 1
        ld      b, h            ; Copy number of buffers
        ld      c, l
#else
        ld      hl, #2          ; Pointer to parameter
        add     hl, sp
        ld      c, (hl)         ; Load the parameter
        inc     hl
        ld      b, (hl)
#endif
        ld      a, (page)       ; Get current memory page
        push    af              ; Save it
        and     #0x0F           ; Select ROM 0
        ld      (page), a
        out     (0x00), a
        call    conok           ; Allocate the buffers
        pop     af              ; Restore original memory page
        ld      (page), a
        out     (0x00), a
        ret
    __endasm;
    }
