//  setdma.c - Set DMA address

#include <diskio.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
   Set DMA address. Note: If the input address is NULL, the DMA address is not changed.

   This routine is called automatically by routines taking a data address as a parameter.

   addr = New DMA address.
*/

static unsigned int mxl_dma_addr;

void setdma (void *addr) __naked
    {
    addr;
    __asm
        bdos = 0xD706
#if __SDCCCALL != 1
        ld      hl, #2      // Pointer to parameters
        add     hl, sp
        ld      e, (hl)     // DMA address
        inc     hl
        ld      d, (hl)
        inc     hl
#endif
mxl_setdma::
        ld      a, d        // Test for NULL
        or      e
        ret     z
        ld      (_mxl_dma_addr), de
        ld      c, #0x1A    // Set DMA address
        jp      bdos        // Perform the action
    __endasm;
    }

unsigned int mxl_get_dma (void) __naked
    {
    __asm
        ld      hl, (_mxl_dma_addr)
        ret
    __endasm;
    }
