//  sound3.c - Set a sound channel

#include <mtxsnd.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
    Starts a sound. The sound will continue untill changed by another command.

    chan = Sound channel (0 - 3).
    freq = Frequency (0 - 1023).
    vol = Volume (0 - 15).

*/

void sound3 (unsigned int chan, unsigned int freq, unsigned int vol) __naked
    {
    chan; freq; vol;
    __asm
        diout0 = 0x08F6
        chan = 0xFE14
#if __SDCCCALL == 1
        ld      (chan), hl      ; Save the channel number
        ld      (chan+2), de    ; Save the frequency
        pop     hl              ; Get the return address
        ex      (sp), hl        ; Exchange return address and volume
        ld      (chan+4), hl    ; And save the volume
#else
        ld      hl, #2          ; Pointer to parameters
        add     hl, sp
        ld      de, #chan       ; Sound system variables
        ld      bc, #6          ; Data size
        ldir                    ; Copy parameters to system variables
#endif
        jp        diout0        ; Process the sound
    __endasm;
    }
