//  sprite.c - Define a sprite

#include <mtxscrn.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
    Defines a sprite:

    n = Sprite number (1 - 32).
    p = Pattern number (0 - 127 for 8x8 sprites, 0 - 31 for 16x16 sprites).
    xp = Horizontal position of sprite centre (0 - 4059).
    yp = Vertical position of sprite centre (0 - 4059).
    xs = Horizontal speed (-128 - 127).
    ys = Vertical speed (-128 - 127).
    c = Colour (0 - 15).

*/

void sprite (unsigned char n, unsigned char p, unsigned int xp, unsigned int yp,
			 signed char xs, signed char ys, unsigned char c) __naked
    {
    n; p; xp; yp; xs; ys; c;
    __asm
        getstr = 0x00BC
#if __SDCCCALL == 1
        push    af              ; Save first parameter (in A)
#endif
        ld      a, #0x12        ; <Ctrl+R>
        call    getstr
        ld      b, #9           ; Nine bytes of parameters
        jp      _mxl_putparam
    __endasm;
    }
