// vdpreg.c - Write a VDP register

#include <mtxvdp.h>

#ifndef __SDCCCALL
#define __SDCCCALL  0
#endif

/**
    Write a VDP register.

    reg =   Register number (0 - 7).
    val =   Value to write.

*/

void vdpreg (unsigned char reg, unsigned char val) __naked
    {
    reg; val;
    __asm
#if __SDCCCALL == 1
        ld      e, a        ; E = register
#else
        pop     hl          ; Return address
        pop     de          ; Parameters
        push    de          ; Restore the stack
        push    hl
        ld      l, d        ; L = val
#endif
        call    getiff      ; Test interrupt status
        push    af
        di
        in      a,(0x02)    ; Read status register
        ld      a, l        ; Output value
        out     (0x02), a
        ld      a, e        ; Select register
        and     #0x07
        or      #0x80
        out     (0x02), a
        pop     af          ; Optionally restore interrupts
        ret     c
        ei
        ret
    __endasm;
    }
